// CompactFramework.cpp : implementation file
//
// Copyright(C) 2008 ubisys technologies GmbH, Duesseldorf, Germany.
// All rights reserved.
//
// www.ubisys.de
// support@ubisys.de
//
// THIS SOURCE CODE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//
// IN NO EVENT SHALL UBISYS TECHNOLOGIES BE LIABLE FOR ANY CLAIM, DAMAGES OR
// OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOURCE CODE OR THE USE OR
// OTHER DEALINGS IN THE SOURCE CODE.
//
// Part of the ubisys(R) 13.56 MHz RFID USB stick demo application
//
// Implements CompactFramework helpers for MacOS X platforms

#include <cstdio>
#include <cstring>
#include <cstdarg>
#include <iostream>
#include <iomanip>
#include "CompactFramework.h"

using namespace std;

void OutputDebugStringEx(const char *const pszFormat, ...)
{
	char szMessage[8192];
	va_list va;
	
	va_start(va, pszFormat);	
	vsnprintf(szMessage, sizeof(szMessage) - 1, pszFormat, va);
	va_end(va);
	
	cerr << szMessage << flush;
}


void OnAssertionFailed(const char *const pszFile, const unsigned int nLine)
{
	TRACE2("ASSERTION FAILED: %s (%d)\r\n", __FILE__, __LINE__);
	exit(1); 
}