// CompactFramework.h : header file
//
// Copyright(C) 2010 ubisys technologies GmbH, Duesseldorf, Germany.
// All rights reserved.
//
// www.ubisys.de
// support@ubisys.de
//
// CompactFramework abstraction layer for the Apple iPhoneOS

/////////////////////////////////////////////////////////////////////////////
// Mixed Objective-C/C++ support

#ifdef __cplusplus
extern "C" {
#endif


/////////////////////////////////////////////////////////////////////////////
// ANSI/UNICODE support

#define _T(s)	s
typedef char TCHAR;


/////////////////////////////////////////////////////////////////////////////
// __debug_break() clone for iPhone and iPhone simulator

#ifdef _DEBUG
void __debug_break(void);
#endif

	
/////////////////////////////////////////////////////////////////////////////
// TRACE macros

#ifdef _DEBUG
void OutputDebugStringEx(const TCHAR *const pszFormat, ...);
#endif

#ifdef _DEBUG 
#define TRACE(...) OutputDebugStringEx(__VA_ARGS__)
#else
#define TRACE(...)
#endif

#define TRACE0(format) \
	TRACE(format)
#define TRACE1(format, arg1) \
	TRACE(format, arg1)
#define TRACE2(format, arg1, arg2) \
	TRACE(format, arg1, arg2)
#define TRACE3(format, arg1, arg2, arg3) \
	TRACE(format, arg1, arg2, arg3)
#define TRACE4(format, arg1, arg2, arg3, arg4) \
	TRACE(format, arg1, arg2, arg3, arg4)
#define TRACE5(format, arg1, arg2, arg3, arg4, arg5) \
	TRACE(format, arg1, arg2, arg3, arg4, arg5)
#define TRACE6(format, arg1, arg2, arg3, arg4, arg5, arg6) \
	TRACE(format, arg1, arg2, arg3, arg4, arg5, arg6)
#define TRACE7(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7) \
	TRACE(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7)
#define TRACE8(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8) \
	TRACE(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8)
#define TRACE9(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9) \
	TRACE(format, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)

/////////////////////////////////////////////////////////////////////////////
// ASSERT and VERIFY macros

#ifdef _DEBUG
void OnAssertionFailed(const char *const pszFile, const unsigned int nLine);
#endif

#ifdef _DEBUG
#define ASSERT(e)	\
	{ \
		if (!(e)) \
			OnAssertionFailed(__FILE__, __LINE__); \
	}
#define VERIFY(e) \
	{ \
		if (!(e)) \
			OnAssertionFailed(__FILE__, __LINE__); \
	}
#else
#define ASSERT(e)
#define VERIFY(e)	(e)
#endif

/////////////////////////////////////////////////////////////////////////////
// ASSERT_VALIDHEAPBLOCK (limited support at present time)

#define ASSERT_VALIDHEAPBLOCK(p, n)	ASSERT(p)


/////////////////////////////////////////////////////////////////////////////
// Mixed Objective-C/C++ support
	
#ifdef __cplusplus
} // end of extern "C" block
#endif
